Subject: [Lsr] draft-ietf-lsr-flex-algo-17 (was: I-D Action: draft-ietf-lsr-flex-algo-bw-con-01.txt)

From: Ron Bonica <[email-masked]>
Date: Mon, 26 Jul 2021 16:36:30 +0000

Acee,

We may also need to clean up an inconsistency in draft-ietf-lsr-flex-algo-17. Section 12 of that document says:

"   Link attribute advertisements that are to be used during Flex-
   Algorithm calculation MUST use the Application-Specific Link
   Attribute (ASLA) advertisements defined in [RFC8919] or [RFC8920],
   unless, in the case of IS-IS, the L-Flag is set in the ASLA
   advertisement.  If the L-Flag is set, as defined in [RFC8919]
   Section 4.2 subject to the constraints discussed in Section 6 of the
   [[RFC8919], then legacy advertisements are to be used instead. "

However, Flex-Algorithm calculations include the IGP metric.

                                                                   Ron

Juniper Business Use Only

-----Original Message-----
From: Acee Lindem (acee) <acee=[email-masked]> 
Sent: Friday, July 23, 2021 10:13 AM
To: Ron Bonica <[email-masked]>; Les Ginsberg (ginsberg) <[email-masked]>; Shraddha Hegde <[email-masked]>; [email-masked]; Peter Psenak (ppsenak) <[email-masked]>; [email-masked]
Cc: [email-masked]
Subject: Re: [Lsr] I-D Action: draft-ietf-lsr-flex-algo-bw-con-01.txt

[External Email. Be cautious of content]

Hi Ron,

So perhaps, generic metric is not a legacy advertisement as strictly defined. However, we don't want to go down the path of treating new attributes in the same manner as legacy attributes. It seems the discussion is progressing and hopefully we will have a resolution.

Thanks,
Acee

On 7/22/21, 1:28 PM, "Ron Bonica" <rbonica=[email-masked]> wrote:

    Acee,

    I don't think that draft-ietf-lsr-flex-algo-bw-con violates RFC 8919.

    Section 6.1 of RFC 8919 says:

    " New applications that future documents define to make use of the
       advertisements defined in this document MUST NOT make use of legacy
       advertisements.  This simplifies deployment of new applications by
       eliminating the need to support multiple ways to advertise attributes
       for the new applications."

    Section 3 of RFC 8919 defines legacy advertisements. The definition of legacy
    advertisements does not include new attributes such as
    generic metric. Therefore draft-ietf-lsr-flex-algo-bw-con does not
    violate RFC 8919

    Relevant text from Section 3 of RFC 8919 is included below for convenience.

                                                                          Ron

    RFC 8919, Section 3
    ---------------------------
    3.  Legacy Advertisements

    Existing advertisements used in support of RSVP-TE include sub-TLVs
       for TLVs 22, 23, 25, 141, 222, and 223 and TLVs for Shared Risk Link
       Group (SRLG) advertisement.

       Sub-TLV values are defined in the "Sub-TLVs for TLVs 22, 23, 25, 141,
       222, and 223" registry.

       TLVs are defined in the "TLV Codepoints Registry".

    3.1.  Legacy Sub-TLVs

       +======+====================================+
       | Type | Description                        |
       +======+====================================+
       | 3    | Administrative group (color)       |
       +------+------------------------------------+
       | 9    | Maximum link bandwidth             |
       +------+------------------------------------+
       | 10   | Maximum reservable link bandwidth  |
       +------+------------------------------------+
       | 11   | Unreserved bandwidth               |
       +------+------------------------------------+
       | 14   | Extended Administrative Group      |
       +------+------------------------------------+
       | 18   | TE Default Metric                  |
       +------+------------------------------------+
       | 33   | Unidirectional Link Delay          |
       +------+------------------------------------+
       | 34   | Min/Max Unidirectional Link Delay  |
       +------+------------------------------------+
       | 35   | Unidirectional Delay Variation     |
       +------+------------------------------------+
       | 36   | Unidirectional Link Loss           |
       +------+------------------------------------+
       | 37   | Unidirectional Residual Bandwidth  |
       +------+------------------------------------+
       | 38   | Unidirectional Available Bandwidth |
       +------+------------------------------------+
       | 39   | Unidirectional Utilized Bandwidth  |
       +------+------------------------------------+

           Table 1: Sub-TLVs for TLVs 22, 23, 25,
                     141, 222, and 223

    Juniper Business Use Only

    -----Original Message-----
    From: Lsr <[email-masked]> On Behalf Of Acee Lindem (acee)
    Sent: Tuesday, July 20, 2021 1:21 PM
    To: Les Ginsberg (ginsberg) <ginsberg=[email-masked]>; Shraddha Hegde <[email-masked]>; [email-masked]; ppsenak=[email-masked]; [email-masked]
    Cc: [email-masked]
    Subject: Re: [Lsr] I-D Action: draft-ietf-lsr-flex-algo-bw-con-01.txt

    [External Email. Be cautious of content]

    Speaking as WG member:

    I agree with Les. The Generic Metric MUST be advertised as an ASLA for usage in Flex Algorithm. Additionally, it may be advertised as a sub-TLV in IS-IS link TLVs. However, the latter encoding really shouldn't be used for new applications (at least that is my reading of RFC 8919).

    For OSPF, I'd certainly hope one wouldn't originate additional LSAs when an ASLA can support the legacy applications with the ASLA mask.

    Thanks,
    Acee

---

From: Peter Psenak <[email-masked]>
Date: Mon, 26 Jul 2021 19:30:34 +0200

Hi Ron,

> However, Flex-Algorithm calculations include the IGP metric.

IGP metric is not advertised as a link attribute, it is part of the 
fixed portion of the link advertisement. So the above text is not 
affecting the usage if the IGP metric.

thanks,
Peter

---

From: Ron Bonica <[email-masked]>
Date: Mon, 26 Jul 2021 18:30:58 +0000

Peter,

I think that we are using the term "link attribute" differently. IMO, a link attribute is any attribute of a link, regardless of whether it is advertised in the fixed portion of a link advertisement or in a TLV. 

Are you assuming otherwise? If so, why?

                                                           Ron

-----Original Message-----
From: Peter Psenak <[email-masked]> 
Sent: Monday, July 26, 2021 1:31 PM
To: Ron Bonica <[email-masked]>; Acee Lindem (acee) <acee=[email-masked]>; Les Ginsberg (ginsberg) <[email-masked]>; Shraddha Hegde <[email-masked]>; [email-masked]; [email-masked]
Cc: [email-masked]
Subject: Re: draft-ietf-lsr-flex-algo-17 (was: [Lsr] I-D Action: draft-ietf-lsr-flex-algo-bw-con-01.txt)

Hi Ron,

> However, Flex-Algorithm calculations include the IGP metric.

IGP metric is not advertised as a link attribute, it is part of the fixed portion of the link advertisement. So the above text is not affecting the usage if the IGP metric.

thanks,
Peter

> To: Ron Bonica <[email-masked]>; Les Ginsberg (ginsberg) 
> <[email-masked]>; Shraddha Hegde <[email-masked]>; 
> [email-masked]; Peter Psenak (ppsenak) <[email-masked]>; 
> [email-masked]

---

From: Peter Psenak <[email-masked]>
Date: Mon, 26 Jul 2021 20:45:15 +0200

Hi Ron,

> Are you assuming otherwise? If so, why?

when we are talking about the advertisement of the link attributes, we 
are talking about something that is advertised separately and 
optionally, not something that is part of the fixed portion of the link 
advertisement.

If that is not clear, I can make that statement in the flex-algo draft, 
but that would not remove the mandatory usage of the ASLA for the 
(optional) attributes.

thanks,
Peter

---

From: "Les Ginsberg (ginsberg)" <[email-masked]>
Date: Mon, 26 Jul 2021 19:08:42 +0000

Ron -

Link attributes have since Day 1 (i.e., publication of RFC 3784 (precursor to RFC 5305)) been associated with sub-TLV advertisements.
Both RFC 8919 and the Flex Algo draft are discussing attributes advertised in sub-TLVs.

IGP metric has never been advertised in a sub-TLV (or even proposed to be). Therefore it isn’t at all clear to me why you think anything regarding encoding of link attributes discussed in the above documents could or should be applied to IGP metric advertisement.

It may be true that "link attributes" could be interpreted to apply to aspects advertised in TLV 22 base encoding. This includes: Neighbor system-id and IGP metric.
Are you confused about both of these? Do you believe that ASLA/Flex documents could be interpreted to apply to Neighbor ID as well as IGP metric?
If so, then you need to explain how you reached this conclusion as I do not understand it.

   Les

> From: Ron Bonica <[email-masked]>
> Sent: Monday, July 26, 2021 11:31 AM
> To: Peter Psenak (ppsenak) <[email-masked]>; Acee Lindem (acee)
> <acee=[email-masked]>; Les Ginsberg (ginsberg)
> [email-masked]; [email-masked]
> Subject: RE: draft-ietf-lsr-flex-algo-17 (was: [Lsr] I-D Action: draft-ietf-lsr-
> flex-algo-bw-con-01.txt)
> 
> Peter,
> 
> I think that we are using the term "link attribute" differently. IMO, a link
> attribute is any attribute of a link, regardless of whether it is advertised in the
> fixed portion of a link advertisement or in a TLV.
> 
> To: Ron Bonica <[email-masked]>; Acee Lindem (acee)
> <acee=[email-masked]>; Les Ginsberg (ginsberg)
> [email-masked]; [email-masked]
> IGP metric is not advertised as a link attribute, it is part of the fixed portion of
> the link advertisement. So the above text is not affecting the usage if the IGP
> metric.
> 
> thanks,
> Peter
> 
> 
> >
> >
> > Ron
> >
> >
> >
> > So perhaps, generic metric is not a legacy advertisement as strictly defined.
> However, we don't want to go down the path of treating new attributes in
> the same manner as legacy attributes. It seems the discussion is progressing
> and hopefully we will have a resolution.
> >
> > Thanks,
> > Acee
> >
> > On 7/22/21, 1:28 PM, "Ron Bonica"
> <rbonica=[email-masked]> wrote:
> >
> >      Acee,
> >
> >      To: Les Ginsberg (ginsberg) <ginsberg=[email-masked]>;
> Shraddha Hegde <[email-masked]>; [email-masked];
> ppsenak=[email-masked]; [email-masked]
> >      I agree with Les. The Generic Metric MUST be advertised as an ASLA for
> usage in Flex Algorithm. Additionally, it may be advertised as a sub-TLV in IS-
> IS link TLVs. However, the latter encoding really shouldn't be used for new
> applications (at least that is my reading of RFC 8919).
> >
> >      For OSPF, I'd certainly hope one wouldn't originate additional LSAs when
> an ASLA can support the legacy applications with the ASLA mask.
> >
> >      Thanks,
> >      Acee
> >
> >
> >
> >

---

From: Ron Bonica <[email-masked]>
Date: Tue, 27 Jul 2021 17:32:15 +0000

Peter,

I agree that we will need to update the flexago draft. But before we do that, can you explain why we need to maintain mandatory use of ASLA?

AFAIKS, by their nature, some attributes are generic while others are application specific. For example, a link's total physical bandwidth is generic, by nature. It will always be the same for all applications. By contrast, the amount of bandwidth available to a specific application is application specific, by nature. It can be different for each application.

                                                          Ron

-----Original Message-----
From: Peter Psenak <[email-masked]> 
Sent: Monday, July 26, 2021 2:45 PM
To: Ron Bonica <[email-masked]>; Acee Lindem (acee) <acee=[email-masked]>; Les Ginsberg (ginsberg) <[email-masked]>; Shraddha Hegde <[email-masked]>; [email-masked]; [email-masked]
Cc: [email-masked]
Subject: Re: draft-ietf-lsr-flex-algo-17 (was: [Lsr] I-D Action: draft-ietf-lsr-flex-algo-bw-con-01.txt)

Hi Ron,

> Are you assuming otherwise? If so, why?

when we are talking about the advertisement of the link attributes, we are talking about something that is advertised separately and optionally, not something that is part of the fixed portion of the link advertisement.

If that is not clear, I can make that statement in the flex-algo draft, but that would not remove the mandatory usage of the ASLA for the
(optional) attributes.

thanks,
Peter

---

From: Robert Raszuk <[email-masked]>
Date: Tue, 27 Jul 2021 21:04:57 +0200

Hi Ron,

I think you are not taking into consideration the full picture here and
instead you are only focusing only on signaling.

So let's take your example of "link's total physical bandwidth" Yes physics
wise it is generic, by nature.

And that claim is true too: "It will always be the same for all
applications."

But how do you know which applications should use it in the computation of
their topology and which do not ?

Are you saying it would be obligatory/mandatory to all applications because
you defined it to be generic ? What if I do not want to use it for
flex-algo topo 25 ?

Remember signalling by itself is useless till it allows network wide
**consistent** use in topology computation. And if your answer would be:
"Oh it would be configuration dependent node by node" then I am afraid this
would melt lots of networks pretty badly.

Cheers,
Robert
.

On Tue, Jul 27, 2021 at 7:32 PM Ron Bonica <rbonica=
[email-masked]> wrote:

> Peter,
>
> I agree that we will need to update the flexago draft. But before we do
> that, can you explain why we need to maintain mandatory use of ASLA?
>
> AFAIKS, by their nature, some attributes are generic while others are
> application specific. For example, a link's total physical bandwidth is
> generic, by nature. It will always be the same for all applications. By
> contrast, the amount of bandwidth available to a specific application is
> application specific, by nature. It can be different for each application.
>
>                                                           Ron
>
>
>
>
> To: Ron Bonica <[email-masked]>; Acee Lindem (acee) <acee=
> [email-masked]>; Les Ginsberg (ginsberg) <[email-masked]>;
> > I think that we are using the term "link attribute" differently. IMO, a
> link attribute is any attribute of a link, regardless of whether it is
> advertised in the fixed portion of a link advertisement or in a TLV.
> >
> when we are talking about the advertisement of the link attributes, we are
> talking about something that is advertised separately and optionally, not
> something that is part of the fixed portion of the link advertisement.
>
> >> We may also need to clean up an inconsistency in
> draft-ietf-lsr-flex-algo-17. Section 12 of that document says:
> >>
> fixed portion of the link advertisement. So the above text is not affecting
> the usage if the IGP metric.
> >
> > thanks,
> > Peter
> >
> >
> >>
> >>
> >> Ron
> >>
> >>
> >>
> >> So perhaps, generic metric is not a legacy advertisement as strictly
> defined. However, we don't want to go down the path of treating new
> attributes in the same manner as legacy attributes. It seems the discussion
> is progressing and hopefully we will have a resolution.
> >>
> >> Thanks,
> >> Acee
> >>
> Shraddha Hegde <[email-masked]>; [email-masked]; ppsenak=
> [email-masked]; [email-masked]
> >>       I agree with Les. The Generic Metric MUST be advertised as an
> ASLA for usage in Flex Algorithm. Additionally, it may be advertised as a
> sub-TLV in IS-IS link TLVs. However, the latter encoding really shouldn't
> be used for new applications (at least that is my reading of RFC 8919).
> >>
> >>       For OSPF, I'd certainly hope one wouldn't originate additional
> LSAs when an ASLA can support the legacy applications with the ASLA mask.
> >>
> >>       Thanks,
> >>       Acee
> >>
> >>
> >>
> >>
> >
> >
> _______________________________________________
> Lsr mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/lsr
>

---

From: Peter Psenak <[email-masked]>
Date: Wed, 28 Jul 2021 16:51:07 +0200

Ron,

the problem in hand is whether Generic Metric should be defined as an 
application specific attribute or not. I have explained several times 
why making it application specific makes sense and also provided 
examples of other metrics that are defined as application specific (TE 
metric, Delay). There also seems to be sufficient support from the WG to 
make Generic Metric an application specific link attribute.

If Generic Metric is defined as an application specific attribute, it 
MUST be advertised in ASLA and only ASLA advertisement MUST be used by 
flex-algo application.

The discussion about application specific nature of Generic Metric is 
orthogonal to what draft-ietf-lsr-flex-algo-17 says.

If you feel the text in draft-ietf-lsr-flex-algo-17 needs to be 
improved, we can do that once the discussion about the Generic Metric 
being application specific or not is closed.

thanks,
Peter

---

From: Shraddha Hegde <[email-masked]>
Date: Wed, 28 Jul 2021 18:16:48 +0000

Peter,

  There is an agreement to open the Flex-algo draft and clarify the text
   and here is a proposal for the modified text.
   We can discuss about generic-metric in another thread. 
   
   New text for section "12.  Advertisement of Link Attributes for Flex-Algorithm  " 2 nd
And 3rd paragraph.   

  " Link attribute advertisements that are to be used during Flex-
   Algorithm calculation MUST use the Application-Specific Link
   Attribute (ASLA) advertisements defined in [RFC8919] or [RFC8920],
   except for the following exceptions.
   
   1. In the case of IS-IS, the L-Flag is set in the ASLA
      advertisement.  If the L-Flag is set, as defined in [RFC8919]
      Section 4.2 subject to the constraints discussed in Section 6 of the
      [[RFC8919], then legacy advertisements MUST be used instead.
   2. There is no way to advertise igp-metric in ASLA advertisements. 
      The Flex-Algorithm calculation MUST use igp-metric
      from legacy advertisements in ISIS and OSPF.
   3. In OSPF, application-independent attributes such as maximum-link-bandwidth
      are advertised in non-ASLA advertisements.
      The Flex-Algorithm calculation in OSPF MUST use non-ASLA advertisements
      for application-independent attributes.
   4. In IS-IS, application-independent attributes such as maximum-link-bandwidth
      can be advertised in both ASLA advertisements and legacy advertisements.
      The Flex-Algorithm calculation in IS-IS MAY use legacy advertisements
       for application-independent attributes.

   The mandatory use of ASLA advertisements applies to link attributes
   specifically mentioned in this document (Min Unidirectional Link
   Delay, TE Default Metric, Administrative Group, Extended
   Administrative Group and Shared Risk Link Group) and any other 
   application-specific link
   attributes that may be used in support of Flex-Algorithm in the
   future."

Rgds
Shraddha

-----Original Message-----
From: Peter Psenak <[email-masked]> 
Sent: Wednesday, July 28, 2021 8:21 PM
To: Ron Bonica <[email-masked]>; Acee Lindem (acee) <acee=[email-masked]>; Les Ginsberg (ginsberg) <[email-masked]>; Shraddha Hegde <[email-masked]>; [email-masked]; [email-masked]
Cc: [email-masked]
Subject: Re: draft-ietf-lsr-flex-algo-17 (was: [Lsr] I-D Action: draft-ietf-lsr-flex-algo-bw-con-01.txt)

Ron,

the problem in hand is whether Generic Metric should be defined as an application specific attribute or not. I have explained several times why making it application specific makes sense and also provided examples of other metrics that are defined as application specific (TE metric, Delay). There also seems to be sufficient support from the WG to make Generic Metric an application specific link attribute.

If Generic Metric is defined as an application specific attribute, it MUST be advertised in ASLA and only ASLA advertisement MUST be used by flex-algo application.

The discussion about application specific nature of Generic Metric is orthogonal to what draft-ietf-lsr-flex-algo-17 says.

If you feel the text in draft-ietf-lsr-flex-algo-17 needs to be improved, we can do that once the discussion about the Generic Metric being application specific or not is closed.

thanks,
Peter

On 27/07/2021 19:32, Ron Bonica wrote:
> If that is not clear, I can make that statement in the flex-algo 
> draft, but that would not remove the mandatory usage of the ASLA for 
> the
> (optional) attributes.
>
>
> thanks,
> Peter
>
>>
>>                                                              Ron
>>
>>
>>
>>> [email-masked]; Peter Psenak (ppsenak) 
>>> <[email-masked]>; [email-masked]

---

From: Shraddha Hegde <[email-masked]>
Date: Fri, 30 Jul 2021 23:04:12 +0000

WG,

This is proposed text change for flex-algo draft.
Any comments on this?

Rgds
Shraddha

-----Original Message-----
From: Shraddha Hegde <[email-masked]> 
Sent: Wednesday, July 28, 2021 11:47 PM
To: Peter Psenak <[email-masked]>; Ron Bonica <[email-masked]>; Acee Lindem (acee) <acee=[email-masked]>; Les Ginsberg (ginsberg) <[email-masked]>; [email-masked]; [email-masked]
Cc: [email-masked]
Subject: RE: draft-ietf-lsr-flex-algo-17 (was: [Lsr] I-D Action: draft-ietf-lsr-flex-algo-bw-con-01.txt)

Peter,

   

Rgds
Shraddha

-----Original Message-----
From: Peter Psenak <[email-masked]>
Sent: Wednesday, July 28, 2021 8:21 PM
To: Ron Bonica <[email-masked]>; Acee Lindem (acee) <acee=[email-masked]>; Les Ginsberg (ginsberg) <[email-masked]>; Shraddha Hegde <[email-masked]>; [email-masked]; [email-masked]
Cc: [email-masked]
Subject: Re: draft-ietf-lsr-flex-algo-17 (was: [Lsr] I-D Action: draft-ietf-lsr-flex-algo-bw-con-01.txt)

Ron,

thanks,
Peter